from netgen.geom2d import *
from netgen.geom2d import SplineGeometry

periodic = SplineGeometry()
periodic.AddCircle ( (0.31020162, 0.537284966), r=0.3, leftdomain=2, rightdomain=1, bc="cyl")
pnts = [(-0.31020162,0.537284966), (0,0) , (0.620403239,0), (0.930604859,0.537284966), (0.620403239,1.074569932), (0,1.074569932) ]
pnums = [periodic.AppendPoint(*p) for p in pnts]

# This should be our master edges] so we need to save its number.
lbottoml = periodic.Append ( ["line", pnums[0], pnums[1]],bc="periodic")
lbottomm = periodic.Append ( ["line", pnums[1], pnums[2]],bc="periodic")
lbottomr = periodic.Append ( ["line", pnums[2], pnums[3]],bc="periodic")



# Slave boundaries must be defined in the same direction as master ones,
# this is why the the point numbers of this spline are defined in the reverse direction,
# leftdomain and rightdomain must therefore be switched as well!
# We use the master number as the copy argument to create a slave edge.

periodic.Append ( ["line", pnums[0], pnums[5]], leftdomain=0, rightdomain=1, copy=lbottoml, bc="periodic")
periodic.Append ( ["line", pnums[5], pnums[4]], leftdomain=0, rightdomain=1, copy=lbottomm, bc="periodic")
periodic.Append ( ["line", pnums[4], pnums[3]], leftdomain=0, rightdomain=1, copy=lbottomr, bc="periodic")


from ngsolve import *
mesh = Mesh(periodic.GenerateMesh(maxh=0.1))
mesh.SecondOrder()